=== doc/CMakeLists.txt ===
ecm_optional_add_subdirectory(desktop)
ecm_optional_add_subdirectory(kwindecoration)
ecm_optional_add_subdirectory(kwinscreenedges)
ecm_optional_add_subdirectory(kwintabbox)
ecm_optional_add_subdirectory(windowbehaviour)
ecm_optional_add_subdirectory(windowspecific)
ecm_optional_add_subdirectory(kwineffects)
