=== tabbox/CMakeLists.txt ===
# Install the KWin/WindowSwitcher service type
install(FILES kwinwindowswitcher.desktop DESTINATION ${SERVICETYPES_INSTALL_DIR})
install(FILES kwindesktopswitcher.desktop DESTINATION ${SERVICETYPES_INSTALL_DIR})
