=== debian/changelog ===
kwin (4:5.20.5-1) unstable; urgency=medium

  * New upstream release (5.20.5).

 -- Norbert Preining <norbert@preining.info>  Wed, 06 Jan 2021 23:50:52 +0900

kwin (4:5.20.4-4) unstable; urgency=medium

  * Enable pipewire support by adding the respective B-D.

 -- Norbert Preining <norbert@preining.info>  Mon, 28 Dec 2020 09:44:54 +0900

kwin (4:5.20.4-3) unstable; urgency=medium

  * Release to unstable.

 -- Norbert Preining <norbert@preining.info>  Tue, 22 Dec 2020 11:04:37 +0900

kwin (4:5.20.4-2) experimental; urgency=medium

  * Rebuild for Qt transition.

 -- Norbert Preining <norbert@preining.info>  Sun, 13 Dec 2020 00:38:11 +0900

kwin (4:5.20.4-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.20.4).
  * Update and tighten dependencies.
  * Update list of installed files.
  * Update lintian overrides.
  * Update symbols.
  * Remove upstream included d/p/duplicate-property-warning.patch.

  [ Aurélien COUDERC ]
  * Backport upstream patch to fix left-edge dead pixel for click and scroll
    events.

  [ Pino Toscano ]
  * Switch the transitional libxcb-util0-dev build dependency to
    libxcb-util-dev.
  * Bump Standards-Version to 4.5.1, no changes required.
  * Trim trailing whitespace.
  * Set field Upstream-Contact in debian/copyright.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).
  * Update lintian overrides.

  [ Scarlett Moore ]
  * Bump kwin-common recommends/suggest plasma depends to current release.
  * Update upstream/metadata.
    - Repositories to invent.kde.org.
    - Added bug database.
    - Updated changelog to point to announcements.
  * Remove LD_FLAGS override, no longer needed, --as-needed is default now.
  * Add hardening options +all.

 -- Norbert Preining <norbert@preining.info>  Wed, 09 Dec 2020 14:17:32 +0900

kwin (4:5.19.5-3) unstable; urgency=medium

  * Release to unstable.

 -- Norbert Preining <norbert@preining.info>  Fri, 06 Nov 2020 08:37:23 +0900

kwin (4:5.19.5-2) experimental; urgency=medium

  [ Scarlett Moore ]
  * Fix "FTBFS: egl_dmabuf.cpp:97:9: error: EGL_TEXTURE_Y_XUXV_WL
    was not declared in this scope" Apply upstream commit
    2c76cc4784382b3df9b5413860d0793ea26cea31 which addresses the misuse
    of private headers.
    (Closes: #973149)
  * Add salsa-ci config so we can build on salsa.

 -- Norbert Preining <norbert@preining.info>  Mon, 02 Nov 2020 09:39:13 +0900

kwin (4:5.19.5-1) experimental; urgency=medium

  * New upstream release (5.19.5).
  * Add Patrick and myself to uploaders.

 -- Norbert Preining <norbert@preining.info>  Mon, 19 Oct 2020 13:45:27 +0900

kwin (4:5.19.4-1) experimental; urgency=medium

  * Team upload.

  [ Jiří Paleček ]
  * New versions of dependencies for 5.18.5
  * Install new files
  * Use dh-python3
  * Add some patches, fixing compile warnings (affecting code correctness)
  * Rename libkwineffects12 to -12a
  * Remove some symbols from libkwinglutils

 -- Jiri Palecek <jpalecek@web.de>  Mon, 15 Jun 2020 03:01:07 +0200

kwin (4:5.17.5-4) unstable; urgency=medium

  * Team upload.

  [ Scarlett Moore ]
  * Fix "FTBFS: egl_dmabuf.cpp:97:9: error: EGL_TEXTURE_Y_XUXV_WL
    was not declared in this scope"
    Apply upstream commit 2c76cc4784382b3df9b5413860d0793ea26cea31
    as Fix_misuse_of_EGL_eglmesaext_h.patch
    which addresses the misuse of private headers.
    (Closes: #973149)

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Fri, 30 Oct 2020 23:23:05 -0300

kwin (4:5.17.5-3) unstable; urgency=medium

  * Team upload.

  [ Pino Toscano ]
  * Replace the transitional libfontconfig1-dev build dependency with
    libfontconfig-dev.
  * Add the libxcb-xfixes0-dev dependency to kwin-dev, as the kwin headers use
    xcb/xfixes.h.
  * 'acc' autopkgtest: make it verbose, and copy the logs as artifact if
    requested.
  * Fix typo in kwin-common.maintscript to properly remove the old
    /etc/xdg/kwinswitcher.knsrc conffile.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
  * Update lintian overrides.

  [ Jiří Paleček ]
  * Rules-Requires-Root: no

  [ Norbert Preining ]
  * New upstream release (5.19.4).
  * Remove Maximiliano from Uploaders as requested on IRC.
  * Add Scarlett Moore to Uploaders.
  * Change maintainer in d/control to Debian Qt/KDE Maintainers.
  * Update build-deps with the info from cmake.
  * Update list of installed files.
  * Update symbols files.
  * Unfuzzify patches.
  * Add build-deps for Python.
  * Tighten build-deps for kscreenlocker-dev.
  * Clean up lintian overrides.

 -- Pino Toscano <pino@debian.org>  Fri, 28 Aug 2020 19:04:07 +0200

kwin (4:5.17.5-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Bump Standards-Version to 4.5.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Fri, 14 Feb 2020 20:53:37 +0100

kwin (4:5.17.5-1) experimental; urgency=medium

  * Team upload.

  [ Maximiliano Curia ]
  * New upstream release (5.16.5):
    - work better with NVIDIA drivers (Closes: #925528)
    - properly restore the current desktop from session (Closes: #930538)
  * Salsa CI automatic initialization by Tuco
  * Update build-deps and deps with the info from cmake

  [ Pino Toscano ]
  * New upstream release:
    - add support for zwp_linux_dmabuf (Closes: #892204)
  * Update the build dependencies according to the upstream build system:
    - bump KF packages to 5.62.0
    - bump breeze-dev, kscreenlocker-dev, and libkdecorations2-dev to 5.17
    - add libxcb-util0-dev
    - explicitly add gettext
    - switch from the transitional libfreetype6-dev to libfreetype-dev
  * Drop the migration from kwin-dbg, no more needed after two Debian stable
    releases.
  * Remove breaks/replaces for versions older than oldstable.
  * Pass -DBUILD_TESTING=OFF to cmake to disable the build of tests, as they
    are not run at build time anyway.

